package it.unibas.acim2pincohibernate.controllo;

import it.unibas.acim2pincohibernate.form.FormTarga;
import it.unibas.acim2pincohibernate.form.FormAggiornamentoAutomobile;
import it.unibas.acim2pincohibernate.modello.Automobile;
import it.unibas.acim2pincohibernate.modello.Utente;
import it.unibas.acim2pincohibernate.persistenza.DAOAutomobile;
import it.unibas.acim2pincohibernate.persistenza.DAOException;
import it.unibas.acim2pincohibernate.persistenza.PersistenceManager;
import it.unibas.pinco.azioni.Azione;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class AzioneCercaAutomobileTargaPerAggiornamento implements Azione {
    
    private static Log logger = LogFactory.getLog(AzioneCercaAutomobileTargaPerAggiornamento.class);
    
    private boolean richiestaCorretta(HttpServletRequest request) {
        HttpSession session = request.getSession();
        Utente utente = (Utente)session.getAttribute("utente");
        if (session.isNew() || utente == null || !utente.getRuolo().equals("amministratore")) {
            return false;
        }
        return true;
    }
    
    public String esegui(HttpServletRequest request){
        if (!richiestaCorretta(request)) {
            return "errore";
        }
        HttpSession session = request.getSession(false);
        FormTarga formTarga = new FormTarga();
        formTarga.setTarga(request.getParameter("targa"));
        List errori = formTarga.convalida();
        if (errori.size() != 0) {
            request.setAttribute("formTarga", formTarga);
            request.setAttribute("errori", errori);
            return "erroriConvalida";
        }
        try {
            Automobile automobile = DAOAutomobile.findByTarga(request.getParameter("targa"));
            FormAggiornamentoAutomobile formAutomobile = new FormAggiornamentoAutomobile();
            formAutomobile.setAutomobile(automobile);
            formAutomobile.setTarga(automobile.getTarga());
            formAutomobile.setModello(automobile.getModello());
            formAutomobile.setCilindrata(automobile.getCilindrata() + "");
            request.setAttribute("formAutomobile", formAutomobile);
            session.setAttribute("automobile", automobile);
            return "successo";
        } catch (DAOException se) {
            logger.error(se);
            request.setAttribute("messaggioErrore", "Causa dell'errore: " + se.getMessage());
            return "messaggioErrore";
        } finally {
            PersistenceManager.closeSession();
        }
        
    }
}

