package it.unibas.acim2pincohibernate.controllo;

import it.unibas.acim2pincohibernate.form.FormNome;
import it.unibas.acim2pincohibernate.modello.Utente;
import it.unibas.acim2pincohibernate.persistenza.DAOException;
import it.unibas.acim2pincohibernate.persistenza.DAOProprietario;
import it.unibas.acim2pincohibernate.persistenza.PersistenceManager;
import it.unibas.pinco.azioni.Azione;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class AzioneCercaProprietarioNome implements Azione {
    
    private static Log logger = LogFactory.getLog(AzioneInserisciAutomobile.class);

    private boolean richiestaCorretta(HttpServletRequest request) {
        HttpSession session = request.getSession();
        Utente utente = (Utente)session.getAttribute("utente");
        if (session.isNew() || utente == null || !utente.getRuolo().equals("amministratore")) {
            return false;
        }
        return true;
    }
    
    public String esegui(HttpServletRequest request){
        if (!richiestaCorretta(request)) {
            return "errore";
        }
        HttpSession session = request.getSession(false);
        FormNome formNome = new FormNome();
        formNome.setNome(request.getParameter("nome"));
        List errori = formNome.convalida();
        if (errori.size() != 0) {
            request.setAttribute("formNome", formNome);
            request.setAttribute("errori", errori);
            return "erroriConvalida";
        }
        try {
            List listaProprietari = DAOProprietario.findByNome(request.getParameter("nome"));
            session.setAttribute("listaProprietari", listaProprietari);
            return "successo";
        } catch (DAOException se) {
            logger.error(se);
            request.setAttribute("messaggioErrore", "Causa dell'errore: " + se.getMessage());
            return "messaggioErrore";
        } finally {
            PersistenceManager.closeSession();
        }
        
    }
}

