package it.unibas.acim2pincohibernate.controllo;

import it.unibas.acim2pincohibernate.form.FormTarghe;
import it.unibas.acim2pincohibernate.modello.Automobile;
import it.unibas.acim2pincohibernate.modello.Utente;
import it.unibas.acim2pincohibernate.persistenza.DAOAutomobile;
import it.unibas.acim2pincohibernate.persistenza.DAOException;
import it.unibas.acim2pincohibernate.persistenza.PersistenceManager;
import it.unibas.pinco.azioni.Azione;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class AzioneCercaTarghe implements Azione {

    private static Log logger = LogFactory.getLog(AzioneCercaTarghe.class);

    private boolean richiestaCorretta(HttpServletRequest request) {
        HttpSession session = request.getSession();
        Utente utente = (Utente)session.getAttribute("utente");
        if (session.isNew() || utente == null || !utente.getRuolo().equals("amministratore")) {
            return false;
        }
        return true;
    }

    public String esegui(HttpServletRequest request){
        if (!richiestaCorretta(request)) {
            return "errore";
        }
        HttpSession session = request.getSession(false);
        FormTarghe formTarghe = new FormTarghe();
        formTarghe.setTarga1(request.getParameter("targa1"));
        formTarghe.setTarga2(request.getParameter("targa2"));
        List errori = formTarghe.convalida();
        if (errori.size() != 0) {
            request.setAttribute("formTarghe", formTarghe);
            request.setAttribute("errori", errori);
            return "erroriConvalida";
        }
        try {
			Automobile automobile1 = DAOAutomobile.findByTarga(request.getParameter("targa1"));
			Automobile automobile2 = DAOAutomobile.findByTarga(request.getParameter("targa2"));
            session.setAttribute("automobile1", automobile1);
            session.setAttribute("automobile2", automobile2);
            return "successo";
        } catch (DAOException se) {
            logger.error(se);
            request.setAttribute("messaggioErrore", "Causa dell'errore: " + se.getMessage());
            return "messaggioErrore";
        } finally {
            PersistenceManager.closeSession();
        }

    }
}

