package it.unibas.acim2pincohibernate.controllo;

import it.unibas.acim2pincohibernate.modello.Utente;
import it.unibas.acim2pincohibernate.persistenza.DAOException;
import it.unibas.acim2pincohibernate.persistenza.DAOUtente;
import it.unibas.acim2pincohibernate.persistenza.PersistenceManager;
import it.unibas.pinco.azioni.Azione;
import it.unibas.pinco.framework.PincoException;
import java.util.ArrayList;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class AzioneLogin implements Azione {
    
    private static Log logger = LogFactory.getLog(AzioneLogin.class);

    private boolean richiestaCorretta(HttpServletRequest request) {
        String nomeUtente = request.getParameter("nomeUtente");
        String password = request.getParameter("password");
        if (nomeUtente == null || password == null) {
            return false;
        }
        return true;
    }
    
	public String esegui(HttpServletRequest request) throws PincoException {
        if (!richiestaCorretta(request)) {
            return "errore";
        }
        HttpSession session = request.getSession();
        String nomeUtente = request.getParameter("nomeUtente");
        String password = request.getParameter("password");
        Utente utente = null;
        try {
            PersistenceManager.getSession();
            utente = DAOUtente.findByNomeUtente(nomeUtente);
            List errori = new ArrayList();
            request.setAttribute("errori", errori);
            if (utente == null) {
                errori.add("Il nome utente non esiste");
                return "autenticazioneFallita";
            }
            utente.verifica(password);
            if (!utente.getAutenticato()) {
                errori.add("Password scorretta");
                return "autenticazioneFallita";
            }
            String ruolo = utente.getRuolo();
            if (!ruolo.equals("utente") && !ruolo.equals("amministratore")) {
                errori.add("Utente non autorizzato all'accesso");
                return "autenticazioneFallita";
            }
            session.setAttribute("utente", utente);
            logger.info("Accesso effettuato dall'utente: " + nomeUtente);
            if (ruolo.equals("utente")) {
                return "autenticazioneUtente";
            } else {
                return "autenticazioneAmministratore";
            }
        } catch(DAOException sqle){
            throw new PincoException(sqle);
        } finally {
            PersistenceManager.closeSession();
        }
    }
    
}

