package it.unibas.acim2pincohibernate.controllo;

import it.unibas.acim2pincohibernate.modello.Automobile;
import it.unibas.acim2pincohibernate.modello.Utente;
import it.unibas.acim2pincohibernate.persistenza.DAOAutomobile;
import it.unibas.acim2pincohibernate.persistenza.DAOException;
import it.unibas.acim2pincohibernate.persistenza.PersistenceManager;
import it.unibas.pinco.azioni.Azione;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class AzioneScambiaTarghe implements Azione {

    private static Log logger = LogFactory.getLog(AzioneScambiaTarghe.class);

    private boolean richiestaCorretta(HttpServletRequest request) {
        HttpSession session = request.getSession();
        Utente utente = (Utente)session.getAttribute("utente");
        if (session.isNew() || utente == null || !utente.getRuolo().equals("amministratore")) {
            return false;
        }
        return true;
    }

    public String esegui(HttpServletRequest request){
        if (!richiestaCorretta(request)) {
            return "errore";
        }
        HttpSession session = request.getSession(false);
        Automobile automobile1 = (Automobile)session.getAttribute("automobile1");
        Automobile automobile2 = (Automobile)session.getAttribute("automobile2");
        try {
			PersistenceManager.beginTransaction();
			DAOAutomobile.scambiaTarghe(automobile1, automobile2);
			PersistenceManager.commitTransaction();
            return "successo";
        } catch (DAOException se) {
            logger.error(se);
            request.setAttribute("messaggioErrore", "Causa dell'errore: " + se.getMessage());
            try {
                PersistenceManager.rollbackTransaction();
            } catch (Exception e) {}
            return "messaggioErrore";
        } finally {
            PersistenceManager.closeSession();
        }

    }
}

