package it.unibas.acim2pincohibernate.controllo;

import it.unibas.acim2pincohibernate.modello.Proprietario;
import it.unibas.acim2pincohibernate.modello.Utente;
import it.unibas.acim2pincohibernate.persistenza.DAOProprietario;
import it.unibas.acim2pincohibernate.persistenza.DAOException;
import it.unibas.acim2pincohibernate.persistenza.PersistenceManager;
import it.unibas.pinco.azioni.Azione;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class AzioneSelezionaProprietarioNome implements Azione {
    
    private static Log logger = LogFactory.getLog(AzioneSelezionaProprietarioNome.class);

    private boolean richiestaCorretta(HttpServletRequest request) {
        HttpSession session = request.getSession();
        Utente utente = (Utente)session.getAttribute("utente");
        if (session.isNew() || utente == null || !utente.getRuolo().equals("amministratore")) {
            return false;
        }
        return true;
    }
    
    public String esegui(HttpServletRequest request){
        if (!richiestaCorretta(request)) {
            return "errore";
        }
        HttpSession session = request.getSession(false);
        List listaProprietari = (List)session.getAttribute("listaProprietari");
        int i = Integer.parseInt(request.getParameter("posizione")) - 1;
        Proprietario proprietario = (Proprietario)listaProprietari.get(i);
        try {
            DAOProprietario.caricaAutomobili(proprietario);
            session.setAttribute("proprietario", proprietario);
            return "successo";
        } catch (DAOException se){
            logger.error(se);
            request.setAttribute("messaggioErrore", "Causa dell'errore: " + se.getMessage());
            return "messaggioErrore";
        } finally {
            PersistenceManager.closeSession();
        }
    }
}

