package it.unibas.acim2pincohibernate.controllo;

import it.unibas.acim2pincohibernate.modello.Utente;
import it.unibas.acim2pincohibernate.persistenza.DAOException;
import it.unibas.acim2pincohibernate.persistenza.DAOProprietario;
import it.unibas.acim2pincohibernate.persistenza.PersistenceManager;
import it.unibas.pinco.azioni.Azione;
import java.util.Collection;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
    
public class AzioneStampaElenco implements Azione {
    
    private static Log logger = LogFactory.getLog(AzioneStampaElenco.class);

    private boolean richiestaCorretta(HttpServletRequest request) {
        HttpSession session = request.getSession();
        Utente utente = (Utente)session.getAttribute("utente");
        if (session.isNew() || utente == null) {
            return false;
        }
        return true;
    }
    
    public String esegui(HttpServletRequest request){
        if (!richiestaCorretta(request)) {
            return "errore";
        }
        Collection elenco = null;
        try {
            elenco = DAOProprietario.findAll();
            request.setAttribute("elenco", elenco);
            return "successo";
        } catch (DAOException se){
            logger.error(se);
            request.setAttribute("messaggioErrore", "Causa dell'errore: " + se.getMessage());
            return "messaggioErrore";
        } finally {
            PersistenceManager.closeSession();
        }
    }
}

