package it.unibas.acim2pincohibernate.form;

import it.unibas.acim2pincohibernate.modello.Proprietario;
import it.unibas.acim2pincohibernate.persistenza.DAOException;
import it.unibas.acim2pincohibernate.persistenza.DAOProprietario;
import it.unibas.acim2pincohibernate.persistenza.PersistenceManager;
import it.unibas.pinco.utilita.Convalidatore;
import java.util.ArrayList;
import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class FormCodiceFiscale {

    private static Log logger = LogFactory.getLog(FormCodiceFiscale.class);

    private String codiceFiscale = "";

    public void setCodiceFiscale(String codiceFiscale){
        this.codiceFiscale = codiceFiscale;
    }

    public String getCodiceFiscale(){
        return codiceFiscale;
    }

	public List convalida() {
        List errori = new ArrayList();
        Convalidatore.verificaStringaNonNulla(this.codiceFiscale, "codice fiscale", errori);
        Convalidatore.verificaLunghezzaStringa(this.codiceFiscale, 6, "codice fiscale", errori);
        if (errori.size() == 0) {
            try {
                PersistenceManager.getSession();
                Proprietario proprietario = DAOProprietario.findByCodiceFiscale(this.codiceFiscale);
                if (proprietario == null) {
                    errori.add("Errore: codice fiscale inesistente");
                }
            } catch (DAOException daoe) {
                logger.error(daoe);
            } finally {
                PersistenceManager.closeSession();
            }
        }
        return errori;
    }
}