package it.unibas.acim2pincohibernate.form;

import it.unibas.acim2pincohibernate.modello.Automobile;
import it.unibas.acim2pincohibernate.persistenza.DAOAutomobile;
import it.unibas.acim2pincohibernate.persistenza.DAOException;
import it.unibas.acim2pincohibernate.persistenza.PersistenceManager;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class FormInserimentoAutomobile {
    
    private static Log logger = LogFactory.getLog(FormInserimentoAutomobile.class);

    private String targa;
    private String cilindrata;
    private String modello;
    
    public void setTarga(String targa){
        this.targa = targa;
    }
    
    public String getTarga(){
        return targa;
    }
    
    public void setCilindrata(String cilindrata){
        this.cilindrata = cilindrata;
    }
    
    public String getCilindrata(){
        return cilindrata;
    }
    
    public void setModello(String modello){
        this.modello = modello;
    }
    
    public String getModello(){
        return modello;
    }
    
	public java.util.List convalida(){
        java.util.List errori= new java.util.ArrayList();
        if (this.targa.equals("")) {
            errori.add("Errore nel valore della targa: il valore deve essere non nullo");
        }
        if (this.targa.length() != 7) {
            errori.add("Errore nel valore della targa: la targa deve essere esattamente di 7 caratteri");
        }
        if (errori.size() == 0) {
            try {
                PersistenceManager.getSession();
                Automobile automobile = DAOAutomobile.findByTarga(this.targa);
                if (automobile != null) {
                    errori.add("Errore nel valore della targa: targa gia' esistente nella base di dati");
                }
            } catch (DAOException daoe) {
                logger.error(daoe);
            } finally {
                PersistenceManager.closeSession();
            }
        }
        if(this.modello.equals("")) {
            errori.add("Errore nel valore del modello: il valore deve essere non nullo");
        }
        try{
            int cil = Integer.parseInt(this.cilindrata);
            if(cil < 500 || cil > 3000) {
                errori.add("Errore nel valore della cilindrata: il valore deve essere compreso tra 500 e 3000 cc");
            }
        } catch(NumberFormatException e ){
            errori.add("Errori nel valore della cilindrata: il valore deve essere un numero intero");
        }
        return errori;
    }
    
    
}


