package it.unibas.acim2pincohibernate.form;

import it.unibas.acim2pincohibernate.persistenza.DAOException;
import it.unibas.acim2pincohibernate.persistenza.DAOProprietario;
import it.unibas.acim2pincohibernate.persistenza.PersistenceManager;
import it.unibas.pinco.utilita.Convalidatore;
import java.util.ArrayList;
import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class FormNome {

    private static Log logger = LogFactory.getLog(FormNome.class);

    private String nome = "";

    public void setNome(String nome){
        this.nome = nome;
    }

    public String getNome(){
        return nome;
    }

	public List convalida() {
        List errori = new ArrayList();
        Convalidatore.verificaStringaNonNulla(this.nome, "nome", errori);
        if (this.nome != null && this.nome.indexOf(" ") == -1) {
            errori.add("Errore nel valore del nome: il valore deve contenere nome e cognome");
        }
        if (errori.size() == 0) {
            try {
                PersistenceManager.getSession();
                List listaProprietari = DAOProprietario.findByNome(this.nome);
                if (listaProprietari.size() == 0) {
                    errori.add("Errore: nome inesistente nella base di dati");
                }
            } catch (DAOException daoe) {
                logger.error(daoe);
            } finally {
                PersistenceManager.closeSession();
            }
        }
        return errori;
    }
}