package it.unibas.acim2pincohibernate.form;

import it.unibas.acim2pincohibernate.modello.Automobile;
import it.unibas.acim2pincohibernate.persistenza.DAOAutomobile;
import it.unibas.acim2pincohibernate.persistenza.DAOException;
import it.unibas.acim2pincohibernate.persistenza.PersistenceManager;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class FormTarga {

    private static Log logger = LogFactory.getLog(FormTarga.class);

    private String targa;

    public void setTarga(String targa){
        this.targa = targa;
    }

    public String getTarga(){
        return targa;
    }

	public java.util.List convalida(){
        java.util.List errori= new java.util.ArrayList();
        if (this.targa.equals("")) {
            errori.add("Errore nel valore della prima targa: il valore deve essere non nullo");
        }
        if (this.targa.length() != 7) {
            errori.add("Errore nel valore della prima targa: la targa deve essere esattamente di 7 caratteri");
        }
        if (errori.size() == 0) {
            try {
                PersistenceManager.getSession();
                Automobile automobile = DAOAutomobile.findByTarga(this.targa);
                if (automobile == null) {
                    errori.add("Errore nel valore della prima targa: targa inesistente nella base di dati");
                }
            } catch (DAOException daoe) {
                logger.error(daoe);
            } finally {
                PersistenceManager.closeSession();
            }
        }
        return errori;
    }


}


