package it.unibas.acim2pincohibernate.form;

import it.unibas.acim2pincohibernate.modello.Automobile;
import it.unibas.acim2pincohibernate.persistenza.DAOAutomobile;
import it.unibas.acim2pincohibernate.persistenza.DAOException;
import it.unibas.acim2pincohibernate.persistenza.PersistenceManager;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class FormTarghe {

    private static Log logger = LogFactory.getLog(FormTarghe.class);

    private String targa1;
    private String targa2;

    public void setTarga1(String targa1){
        this.targa1 = targa1;
    }

    public String getTarga1(){
        return targa1;
    }

    public void setTarga2(String targa2){
        this.targa2 = targa2;
    }

    public String getTarga2(){
        return targa2;
    }

	public java.util.List convalida(){
        java.util.List errori= new java.util.ArrayList();
        if (this.targa1.equals("")) {
            errori.add("Errore nel valore della prima targa: il valore deve essere non nullo");
        }
        if (this.targa1.length() != 7) {
            errori.add("Errore nel valore della prima targa: la targa deve essere esattamente di 7 caratteri");
        }
        if (errori.size() == 0) {
            try {
                PersistenceManager.getSession();
                Automobile automobile = DAOAutomobile.findByTarga(this.targa1);
                if (automobile == null) {
                    errori.add("Errore nel valore della prima targa: targa inesistente nella base di dati");
                }
            } catch (DAOException daoe) {
                logger.error(daoe);
            } finally {
                PersistenceManager.closeSession();
            }
        }
        if (this.targa1.equals(this.targa2)) {
            errori.add("Errore nel valore della seconda targa: le due targhe non possono essere uguali");
		}
        if (this.targa2.equals("")) {
            errori.add("Errore nel valore della seconda targa: il valore deve essere non nullo");
        }
        if (this.targa2.length() != 7) {
            errori.add("Errore nel valore della seconda targa: la targa deve essere esattamente di 7 caratteri");
        }
        if (errori.size() == 0) {
            try {
                PersistenceManager.getSession();
                Automobile automobile = DAOAutomobile.findByTarga(this.targa2);
                if (automobile == null) {
                    errori.add("Errore nel valore della seconda targa: targa inesistente nella base di dati");
                }
            } catch (DAOException daoe) {
                logger.error(daoe);
            } finally {
                PersistenceManager.closeSession();
            }
        }
        return errori;
    }


}


