package it.unibas.acim2pincohibernate.persistenza;

import it.unibas.acim2pincohibernate.modello.Automobile;
import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;

public class DAOAutomobile {

    private static Log logger = LogFactory.getLog(DAOAutomobile.class);

    public static Automobile findByTarga(String targa) throws DAOException {
        Automobile automobile = null;
        try {
            Session session = PersistenceManager.getSession();
            Query query = session.createQuery("from Automobile where targa = ?");
            query.setString(0, targa);
            List risultato = query.list();
            if (risultato.size() != 0) {
                automobile = (Automobile)risultato.get(0);
            }
        } catch (HibernateException e) {
            logger.error(e);
            throw new DAOException(e);
        }
        return automobile;
    }
    
    public static void makePersistent(Automobile automobile) throws DAOException {
        try {
            PersistenceManager.getSession().saveOrUpdate(automobile);
        } catch (HibernateException e) {
            logger.error(e);
            throw new DAOException(e);
        }
    }

    public static void makeTransient(Automobile automobile) throws DAOException {
        try {
            PersistenceManager.getSession().delete(automobile);
        } catch (HibernateException e) {
            logger.error(e);
            throw new DAOException(e);
        }
    }

	public static void scambiaTarghe(Automobile automobile1, Automobile automobile2) throws DAOException {
	    if (automobile1 == null || automobile2 == null) {
			throw new IllegalArgumentException("Valori null dei riferimenti");
		}
        try {
			String targa1 = automobile1.getTarga();
			String targa2 = automobile2.getTarga();
			DAOAutomobile.makePersistent(automobile1);
			DAOAutomobile.makePersistent(automobile2);
			automobile1.setTarga("xxx");
			DAOAutomobile.makePersistent(automobile1);
			PersistenceManager.getSession().flush();
			automobile2.setTarga(targa1);
			DAOAutomobile.makePersistent(automobile2);
			PersistenceManager.getSession().flush();
			automobile1.setTarga(targa2);
			DAOAutomobile.makePersistent(automobile1);
        } catch (HibernateException e) {
            logger.error(e);
            throw new DAOException(e);
        }
	}
}



