package it.unibas.acim2pincohibernate.persistenza;

import it.unibas.acim2pincohibernate.modello.Utente;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;

public class DAOUtente {
    
    private static Log logger = LogFactory.getLog(DAOUtente.class);
    
    public static Utente findByNomeUtente(String nomeUtente) throws DAOException {
        Utente utente = null;
        try {
            Session session = PersistenceManager.getSession();
            Query query = session.createQuery("from Utente where nomeutente = ?");
            query.setString(0, nomeUtente);
            List risultato = query.list();
            if (risultato.size() != 0) {
                utente = (Utente)risultato.get(0);
            }
        } catch (HibernateException e) {
            logger.error(e);
            throw new DAOException(e);
        }
        return utente;
    }

}



