package it.unibas.acim2pincohibernate.test.persistenza;

import it.unibas.acim2pincohibernate.modello.Automobile;
import it.unibas.acim2pincohibernate.modello.Proprietario;
import it.unibas.acim2pincohibernate.persistenza.DAOProprietario;
import it.unibas.acim2pincohibernate.persistenza.PersistenceManager;
import junit.framework.TestCase;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class TestDAOProprietario extends TestCase {
    
    private static Log logger = LogFactory.getLog(TestDAOProprietario.class);
    
    private Proprietario proprietario;
    private Proprietario proprietario2;
    private Automobile automobile;
    private Automobile automobile2;
    
    protected void setUp() {
        proprietario = new Proprietario();
        proprietario.setCodiceFiscale("cftest2");
        proprietario.setNome("Proprietario di test");
        proprietario.setCittaDiResidenza("citta di test");
        proprietario.setAnnoPatente(2003);
        proprietario2 = new Proprietario();
        proprietario2.setCodiceFiscale("cftest3");
        proprietario2.setNome("Proprietario di test");
        proprietario2.setCittaDiResidenza("citta di test");
        proprietario2.setAnnoPatente(2003);
        automobile = new Automobile();
        automobile.setTarga("test3");
        automobile.setModello("Modello di test");
        automobile.setCilindrata(2000);
        automobile2 = new Automobile();
        automobile2.setTarga("test4");
        automobile2.setModello("Modello di test");
        automobile2.setCilindrata(2000);
    }
    
    public void testProprietario1() {
        Proprietario tmp = null;
        try {
            PersistenceManager.beginTransaction();
            DAOProprietario.makePersistent(proprietario);
            PersistenceManager.commitTransaction();
            PersistenceManager.closeSession();
            tmp = DAOProprietario.findByCodiceFiscale("cftest2");
            assertNotNull(tmp);
            assertEquals(tmp.getCodiceFiscale(), proprietario.getCodiceFiscale());
            assertEquals(tmp.getNome(), proprietario.getNome());
            assertEquals(tmp.getCittaDiResidenza(), proprietario.getCittaDiResidenza());
            assertEquals(tmp.getAnnoPatente(), proprietario.getAnnoPatente());
        } catch (Exception e) {
            logger.error(e);
            try {
                PersistenceManager.rollbackTransaction();
            } catch (Exception ex) {}
            fail();
        } finally {
            try {
                PersistenceManager.beginTransaction();
                DAOProprietario.makeTransient(tmp);
                PersistenceManager.commitTransaction();
                PersistenceManager.closeSession();
            } catch (Exception e) {}
        }
    }
  
}
